from gettext import gettext as _
encodings = (
#	Codec		   Alias		 Language
	("ISO-8859-1", "iso-8859-1", _("West Europe")),
	("ISO-8859-2", "iso-8859-2", _("Central and Eastern Europe")),
	("ISO-8859-3", "iso-8859-3", _("Esperanto, Maltese")),
	("ISO-8859-4", "iso-8859-4", _("Baltic Languages")),
	("ISO-8859-5", "iso-8859-5", _("Bulgarian, Macedonian, Russian, Serbian")),
	("ISO-8859-6", "iso-8859-6", _("Arabic")),
	("ISO-8859-7", "iso-8859-7", _("Greek")),
	("ISO-8859-8", "iso-8859-8", _("Hebrew")),
	("ISO-8859-9", "iso-8859-9", _("Turkish")),
	("ISO-8859-10", "iso-8859-10", _("Nordic Languages")),
	("ISO-8859-13", "iso-8859-13", _("Baltic Languages")),
	("ISO-8859-14", "iso-8859-14", _("Celtic Languages")),
	("ISO-8859-15", "iso-8859-15", _("Western Europe")),
	("ISO-2022-JP", "iso2022jp", _("Japanese")),
	("ISO-2022-jp-1", "iso2022jp-1", _("Japanese")),
	("ISO-2022-JP-2", "iso2022jp-2", _("Japanese, Chinese, Simplified Chinese")),
	("ISO-2022-JP-2004", "iso2022jp-2004", _("Japanese")),
	("ISO-2022-JP-3", "iso2022jp-3", _("Japanese")),
	("ISO-2022-JP-EXT", "iso2022jp-ext", _("Japanese")),
	("ISO-2022-KR", "csiso2022kr", _("Korean")),
	("BIG5", "csbig5", _("Traditional Chinese")),
	("BIG5HKSCS", "hkscs", _("Traditional Chinese")),
	("SHIFT-JIS", "sjis", _("Japanese")),
	("SHIFT-JIS-2004", "sjis2004", _("Japanese")),
	("SHIFT-JISX0213", "sjisx0213", _("Japanese")),
	("KOI8-R", "koi8_r", _("Russian")),
	("KOI8-U", "koi8_u", _("Ukranian")),
	("CP037", "IBM039", _("English")),
	("CP424", "IBM424", _("Hebrew")),
	("CP437", "437", _("English")),
	("CP500", "IBM500", _("Western Europe")),
	("CP737", "cp737", _("Greek")),
	("CP775", "IBM775", _("Baltic Languages")),
	("CP850", "IBM850", _("Western Europe")),
	("CP852", "IBM852", _("Central and Eastern Europe")),
	("CP855", "IBM855", _("Bulgarian, Macedonian, Russian, ")),
	("CP856", "cp856", _("Hebrew")),
	("CP857", "IBM857", _("Turkish")),
	("CP860", "IBM860", _("Portuguese")),
	("CP861", "IBM861", _("Icelandic")),
	("CP862", "IBM862", _("Hebrew")),
	("CP863", "IBM863", _("Canadian")),
	("CP864", "IBM864", _("Arabic")),
	("CP865", "IBM865", _("Danish, Norwegian")),
	("CP866", "IBM866", _("Russian")),
	("CP869", "IBM869", _("Greek")),
	("CP874", "cp874", _("Thai")),
	("CP875", "cp875", _("Greek")),
	("CP932", "mskanji", _("Japanese")),
	("CP949", "uhc", _("Korean")),
	("CP950", "ms950", _("Traditional Chinese")),
	("CP1006", "cp1006", _("Urdu")),
	("CP1026", "ibm1026", _("Turkish")),
	("CP1140", "ibm1140", _("Western Europe")),
	("CP1250", "windows-1250", _("Central and Eastern Europe")),
	("CP1251", "windows-1251", _("Bulgarian, Macedonian, Russian, Serbian")),
	("CP1252", "windows-1252", _("Western Europe")),
	("CP1253", "windows-1253", _("Greek")),
	("CP1254", "windows-1254", _("Turkish")),
	("CP1255", "windows-1255", _("Hebrew")),
	("CP1256", "windows1256", _("Arabic")),
	("CP1257", "windows-1257", _("Baltic Languages")),
	("CP1258", "windows-1258", _("Vietnamese")),
	("EUC-JP", "ujis", _("Japanese")),
	("EUC-JIS-2004", "eucjis2004", _("Japanese")),
	("EUC-JISX0213", "eucjisx0213", _("Japanese")),
	("EUC-KR", "ksc5601", _("Korean")),
	("GB2312",	"euccn", _("Simplified Chinese")),
	("GBK", 	"ms936", _("Unified Chinese")),
	("GB18030", "gb18030-2000", _("Unified Chinese")),
	("HZ", "hzgb", _("Simplified Chinese")),
	("JOHAB", "cp1361", _("Korean")),
	("MAC-CYRILLIC", "maccyrillic", _("Bulgarian, Macedonian, Russian, Serbian")),
	("MAC-GREEK", 	"macgreek", _("Greek")),
	("MAC-ICELAND", "maciceland", _("Icelandic")),
	("MAC-LATIN2", "maccentraleurope", _("Central and Eastern Europe")),
	("MAC-ROMAN", "macroman", _("Western Europe")),
	("MAC-TURKISH", "macturkish", _("Turkish")),
	("PTCP154", "cp154", _("Kazakh")),
	("UTF-16", "utf16", _("All Languages")),
	("UTF-16-BE", "UTF-16BE", _("All Languages (BMP ONLY)")),
	("UTF-16-LE", "UTF-16LE", _("All Languages (BMP ONLY)")),
	("UTF-7", "U7", _("All Languages")),
	("ASCII", "us-ascii", _("English")),
)
